## qca2 2.1.3

=== CMakeLists.txt ===
# Checking for user explicity defined CMAKE_INSTALL_PREFIX
# It must be done before project(...)
if(NOT CMAKE_INSTALL_PREFIX)
  set(QCA_INSTALL_IN_QT_PREFIX ON)
  # If CMAKE_INSTALL_PREFIX is set in cmake arguments
  unset(CMAKE_INSTALL_PREFIX CACHE)
endif(NOT CMAKE_INSTALL_PREFIX)

project(qca)

if(NOT APPLE)
  cmake_minimum_required(VERSION 2.8.12)
else()
  cmake_minimum_required(VERSION 3.0)
endif()

set(QCA_LIB_MAJOR_VERSION "2")
set(QCA_LIB_MINOR_VERSION "1")
set(QCA_LIB_PATCH_VERSION "3")

# Do not automatically link Qt executables to qtmain target on Windows.
# QCA exucatables use console mode only. Not need to link against
# qtmain.lib.
cmake_policy(SET CMP0020 OLD)

option(BUILD_TESTS "Create test" ON)
option(BUILD_TOOLS "Compile mozcerts and qcatool" ON)
set(BUILD_PLUGINS "auto" CACHE STRING "Plugins for building (also possible values: none, all and auto)")
# BUILD_SHARED_LIBS is cmake variable. Need to change default value.
option(BUILD_SHARED_LIBS "Build shared library" ON)
option(DEVELOPER_MODE "Special developer mode" OFF)

if(APPLE)
  option(OSX_FRAMEWORK "Build a Mac OS X Framework" ON)
else()
  set(OSX_FRAMEWORK OFF)
endif()

find_package(Doxygen)

string(TOLOWER "${BUILD_PLUGINS}" BUILD_PLUGINS)
if(NOT BUILD_PLUGINS)
  set(BUILD_PLUGINS "none")
endif(NOT BUILD_PLUGINS)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules" )

option(QT4_BUILD "Force building with Qt4 even if Qt5 is found")
if (NOT QT4_BUILD)
  find_package(Qt5Core QUIET)
  mark_as_advanced(Qt5Core_DIR)
endif()

include(QcaMacro)

if (Qt5Core_FOUND)
  message(STATUS "Building with Qt5 support")
  # Got from ECM
  # Distros have no ECM. So I just copied required cmake modules.
  find_package(Qt5Transitional REQUIRED Core Network)
  include(ECMQt4To5Porting)

  include(GNUInstallDirs)
  setup_qt5_dirs()
  set(QCA_QT_PC_VERSION "Qt5Core")
  set(QCA_SUFFIX "qt5")
else()
  set(QT_MIN_VERSION "4.7.0")
  set(QT_USE_IMPORTED_TARGETS ON)
  if(BUILD_TESTS)
    find_package(Qt4 REQUIRED QtCore QtNetwork QtTest)
  else(BUILD_TESTS)
    find_package(Qt4 REQUIRED QtCore)
  endif(BUILD_TESTS)
  # WORKAROUND: Seems it must be done in Qt4 find module but didn't
  mark_as_advanced(QT_QMAKE_EXECUTABLE)

  # properly set up compile flags (QT_DEBUG/QT_NO_DEBUG, ...)
  include(${QT_USE_FILE})
  setup_qt4_dirs()
  set(QCA_QT_PC_VERSION "QtCore")
endif()

# QCA can be shared but plugins will be static
# if Qt is static.
if(NOT BUILD_SHARED_LIBS OR QT_IS_STATIC)
  set(STATIC_PLUGINS ON)
  add_definitions(-DQT_STATICPLUGIN)
  set(PLUGIN_TYPE "STATIC")
else(NOT BUILD_SHARED_LIBS OR QT_IS_STATIC)
  set(PLUGIN_TYPE "MODULE")
endif(NOT BUILD_SHARED_LIBS OR QT_IS_STATIC)

set(QCA_SUFFIX "${QCA_SUFFIX}" CACHE STRING "QCA common suffix")
if(QCA_SUFFIX)
  set(QCA_LIB_NAME qca-${QCA_SUFFIX})
  set(QCA_TOOL_NAME qcatool-${QCA_SUFFIX})
  set(MOZCERTS_NAME mozcerts-${QCA_SUFFIX})
  set(QCA_PC_NAME qca2-${QCA_SUFFIX}.pc)
  set(QCA_CONFIG_NAME_BASE "Qca-${QCA_SUFFIX}")
else(QCA_SUFFIX)
  set(QCA_LIB_NAME qca)
  set(QCA_TOOL_NAME qcatool)
  set(MOZCERTS_NAME mozcerts)
  set(QCA_PC_NAME qca2.pc)
  set(QCA_CONFIG_NAME_BASE "Qca")
endif(QCA_SUFFIX)

set(QCA_LIB_VERSION_STRING "${QCA_LIB_MAJOR_VERSION}.${QCA_LIB_MINOR_VERSION}.${QCA_LIB_PATCH_VERSION}")

configure_file("include/QtCrypto/qca_version.h.in" "${CMAKE_BINARY_DIR}/qca_version.h")

if (WIN32)
 set(CMAKE_DEBUG_POSTFIX "d")
 add_definitions(-DWIN32_LEAN_AND_MEAN)
elseif (APPLE)
 set(CMAKE_DEBUG_POSTFIX "_debug")
endif (WIN32)

if (CMAKE_COMPILER_IS_GNUCXX)
   if (CMAKE_SYSTEM_NAME MATCHES Linux)
     add_definitions (-D_DEFAULT_SOURCE)
     # on arm -Wcast-align throws many internal qt warning
     if(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^arm")
       set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-align")
       set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align")
     endif()

     set ( CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wno-long-long -ansi -Wundef -Werror-implicit-function-declaration -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -Wmissing-format-attribute -fno-common")
     set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -ansi -Wundef -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -fno-check-new -fno-common")
   endif (CMAKE_SYSTEM_NAME MATCHES Linux)
endif (CMAKE_COMPILER_IS_GNUCXX)

add_definitions (${QT_DEFINITIONS})
include_directories("include/QtCrypto/")
# for generated files
include_directories(${CMAKE_BINARY_DIR})

if(NOT DEVELOPER_MODE)
  # uninstall target
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

  add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

# Always include srcdir and builddir in include path
# This saves typing ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY} in about every subdir
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# put the include dirs which are in the source or build tree
# before all other include dirs, so the headers in the sources
# are prefered over the already installed ones
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

set(qca_INCLUDEDIR "${CMAKE_CURRENT_SOURCE_DIR}/include" )

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin" )
# Use the same path for shared and static library
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )

if( QCA_INSTALL_IN_QT_PREFIX )
  set(QCA_PREFIX_INSTALL_DIR "${QT_PREFIX_DIR}" CACHE PATH "Directory where qca will install")
  set(QCA_PLUGINS_INSTALL_DIR "${QT_PLUGINS_DIR}" CACHE PATH "Directory where qca plugins will install")
  set(QCA_BINARY_INSTALL_DIR "${QT_BINARY_DIR}" CACHE PATH "Directory where qca plugins will install")
  set(QCA_LIBRARY_INSTALL_DIR "${QT_LIBRARY_DIR}" CACHE PATH "Directory where qca library will install")
  set(QCA_FEATURE_INSTALL_DIR "${QT_MKSPECS_DIR}/features" CACHE PATH "Directory where qca feature file will install")
  if(NOT QCA_SUFFIX)
    set(QCA_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}" CACHE PATH "Directory where qca headers will install")
  else()
    set(QCA_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca headers will install")
  endif()
  set(QCA_DOC_INSTALL_DIR "${QT_DOC_DIR}/html/qca/" CACHE PATH "Directory where qca documentation will install")
  set(QCA_MAN_INSTALL_DIR "${QT_DATA_DIR}/man" CACHE PATH "Directory where qca man pages will install")
else( QCA_INSTALL_IN_QT_PREFIX )
  # Cmake says nothing about LIB_SUFFIX
  # de facto it is a standard way to specify lib suffix on many distros
  set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
  set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "Directory where lib will install")

  set(QCA_PREFIX_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}" CACHE PATH "Directory where qca will install")
  set(QCA_PLUGINS_INSTALL_DIR "${LIB_INSTALL_DIR}/${QCA_LIB_NAME}" CACHE PATH "Directory where qca plugins will install")
  set(QCA_BINARY_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Directory where qca plugins will install")
  set(QCA_LIBRARY_INSTALL_DIR "${LIB_INSTALL_DIR}" CACHE PATH "Directory where qca library will install")
  set(QCA_FEATURE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/mkspecs/features" CACHE PATH "Directory where qca feature file will install")
  if(NOT QCA_SUFFIX)
    set(QCA_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Directory where qca headers will install")
  else()
    set(QCA_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca headers will install")
  endif()
  set(QCA_DOC_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/doc/${QCA_LIB_NAME}/html" CACHE PATH "Directory where qca documentation will install")
  set(QCA_MAN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/man" CACHE PATH "Directory where qca man pages will install")
endif( QCA_INSTALL_IN_QT_PREFIX )

set(PKGCONFIG_INSTALL_PREFIX "${QCA_LIBRARY_INSTALL_DIR}/pkgconfig" CACHE PATH "Base directory for pkgconfig files")

normalize_path(QCA_PREFIX_INSTALL_DIR)

if(OSX_FRAMEWORK)
  set(QCA_FULL_INCLUDE_INSTALL_DIR "${QCA_LIBRARY_INSTALL_DIR}/${QCA_LIB_NAME}.framework/Headers")
else()
  set(QCA_FULL_INCLUDE_INSTALL_DIR "${QCA_INCLUDE_INSTALL_DIR}/QtCrypto")
endif()

# check for oportunity to use relative paths
option(USE_RELATIVE_PATHS "Try to make relocatable package")

foreach(PATH QCA_PLUGINS_INSTALL_DIR
             QCA_BINARY_INSTALL_DIR
             QCA_LIBRARY_INSTALL_DIR
             QCA_FEATURE_INSTALL_DIR
             QCA_INCLUDE_INSTALL_DIR
             QCA_PRIVATE_INCLUDE_INSTALL_DIR
             QCA_DOC_INSTALL_DIR
             QCA_MAN_INSTALL_DIR
             PKGCONFIG_INSTALL_PREFIX)

  # Normalize path before comparsion
  normalize_path(${PATH})

  # if all paths are subdirs of CMAKE_INSTALL_PREFIX it is possible to use relative paths
  string(FIND "${${PATH}}" "${QCA_PREFIX_INSTALL_DIR}/" POS)
  if(NOT "${POS}" STREQUAL "0")
    set(USE_RELATIVE_PATHS OFF)
  endif()
endforeach()

if(NOT WIN32)
  if(OSX_FRAMEWORK)
    set(PKGCONFIG_CFLAGS "-F\${libdir} -I\${includedir}")
    set(PKGCONFIG_LIBS "-F\${libdir} -framework ${QCA_LIB_NAME}")
  else()
    set(PKGCONFIG_CFLAGS "-I\${includedir}")
    set(PKGCONFIG_LIBS "-L\${libdir} -l${QCA_LIB_NAME}")
  endif()

  # qca2.pc uses absolute paths. So it must be there. Don't rellocate this.
  configure_file("qca2.pc.cmake" "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/pkgconfig/${QCA_PC_NAME}" @ONLY)
  if(NOT DEVELOPER_MODE)
    install(FILES "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/pkgconfig/${QCA_PC_NAME}" DESTINATION ${PKGCONFIG_INSTALL_PREFIX})
  endif()
endif(NOT WIN32)

# strip CMAKE_INSTALL_PREFIX in all paths
if(USE_RELATIVE_PATHS)
  message(STATUS "Installed package is relocatable")
  file(RELATIVE_PATH CRYPTO_PRF_RELATIVE_PATH "${QCA_FEATURE_INSTALL_DIR}" ${CMAKE_INSTALL_PREFIX})
  set(CRYPTO_PRF_RELATIVE_PATH "$$PWD/${CRYPTO_PRF_RELATIVE_PATH}")
  foreach(PATH QCA_PLUGINS_INSTALL_DIR
               QCA_BINARY_INSTALL_DIR
               QCA_LIBRARY_INSTALL_DIR
               QCA_FEATURE_INSTALL_DIR
               QCA_INCLUDE_INSTALL_DIR
               QCA_PRIVATE_INCLUDE_INSTALL_DIR
               QCA_DOC_INSTALL_DIR
               QCA_MAN_INSTALL_DIR
               PKGCONFIG_INSTALL_PREFIX)

     file(RELATIVE_PATH ${PATH} ${CMAKE_INSTALL_PREFIX} "${${PATH}}")
  endforeach()
else()
  message(STATUS "Installed package is NOT relocatable")
  set(CRYPTO_PRF_RELATIVE_PATH "")
endif()

if(DEVELOPER_MODE)
  add_definitions(-DDEVELOPER_MODE)

# To prefer plugins from build tree when run qca from build tree
  file(WRITE ${CMAKE_BINARY_DIR}/bin/qt.conf
"[Paths]
Plugins=${CMAKE_BINARY_DIR}/lib/${QCA_LIB_NAME}
")
endif()

if (APPLE)
   set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif (APPLE)

message(STATUS "Checking for certstore..")
# fixme add OR mac
if( WIN32 )
# USE BUILTIN
else ( WIN32 )
  if ( DEFINED ENV{QC_CERTSTORE_PATH} )
    if(EXISTS $ENV{QC_CERTSTORE_PATH})
      set( qca_CERTSTORE $ENV{QC_CERTSTORE_PATH})
    else(EXISTS $ENV{QC_CERTSTORE_PATH})
      # path to try
    endif(EXISTS $ENV{QC_CERTSTORE_PATH})
  else( DEFINED ENV{QC_CERTSTORE_PATH} )
    set( toTry
      "/etc/ssl/certs/ca-certificates.crt"

=== examples/CMakeLists.txt ===
if(Qt5Core_FOUND)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
endif()
add_subdirectory(aes-cmac)
add_subdirectory(base64test)
add_subdirectory(certtest)
add_subdirectory(ciphertest)
add_subdirectory(cms)
# this is not meant to be added, because it introduces
# a dependency on QtGui.
# add_subdirectory(cmssigner)
add_subdirectory(eventhandlerdemo)
add_subdirectory(hashtest)
add_subdirectory(hextest)
add_subdirectory(keyloader)
add_subdirectory(mactest)
add_subdirectory(md5crypt)
add_subdirectory(providertest)
add_subdirectory(publickeyexample)
add_subdirectory(randomtest)
add_subdirectory(rsatest)
add_subdirectory(saslclient)
add_subdirectory(saslserver)
add_subdirectory(ssltest)
add_subdirectory(sslservtest)
add_subdirectory(tlssocket)

=== src/CMakeLists.txt ===
include(CheckIncludeFiles)
CHECK_INCLUDE_FILES(sys/filio.h HAVE_SYS_FILIO_H)
IF(HAVE_SYS_FILIO_H)
  ADD_DEFINITIONS(-DHAVE_SYS_FILIO_H)
ENDIF(HAVE_SYS_FILIO_H)

INCLUDE(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("
# include <stdlib.h>
# include <sys/mman.h>
int main() { void *f = 0; return mlock(f,8); }
" MLOCK_TAKES_VOID)
if(NOT MLOCK_TAKES_VOID)
  MESSAGE(STATUS "mlock(2) does not take a void *")
  ADD_DEFINITIONS(-DMLOCK_NOT_VOID_PTR)
endif(NOT MLOCK_TAKES_VOID)

if(DEVELOPER_MODE)
  add_definitions(-DQCA_PLUGIN_PATH="${CMAKE_BINARY_DIR}/lib/${QCA_LIB_NAME}")
else()
  if(USE_RELATIVE_PATHS)
    add_definitions(-DQCA_PLUGIN_PATH="${QCA_PREFIX_INSTALL_DIR}/${QCA_PLUGINS_INSTALL_DIR}")
  else()
    add_definitions(-DQCA_PLUGIN_PATH="${QCA_PLUGINS_INSTALL_DIR}")
  endif()
endif()

# base source files


SET( nonmoc_SOURCES
	qca_tools.cpp
	qca_plugin.cpp
	qca_textfilter.cpp
	qca_basic.cpp
	support/logger.cpp
)

SET( moc_SOURCES
	qca_cert.cpp
	qca_core.cpp
	qca_default.cpp
	qca_keystore.cpp
	qca_publickey.cpp
	qca_safetimer.cpp
	qca_securelayer.cpp
	qca_securemessage.cpp
	support/qpipe.cpp
	support/console.cpp
	support/synchronizer.cpp
	support/dirwatch.cpp
	support/syncthread.cpp
)

IF (WIN32)
  SET( nonmoc_SOURCES ${nonmoc_SOURCES} qca_systemstore_win.cpp )
elseif(APPLE)
  set( nonmoc_SOURCES ${nonmoc_SOURCES} qca_systemstore_mac.cpp)
else()
  SET( nonmoc_SOURCES ${nonmoc_SOURCES} qca_systemstore_flatfile.cpp )
endif()

# Support files
#SET( qca_HEADERS ${qca_HEADERS} support/dirwatch/dirwatch_p.h )

# Botan tools
SET( botan_BASE botantools/botan )


INCLUDE_DIRECTORIES(${QT_QTCORE_INCLUDE_DIR} support ${botan_BASE} )

ADD_DEFINITIONS(
	-DBOTAN_TYPES_QT
	-DBOTAN_NO_INIT_H
	-DBOTAN_NO_CONF_H
	-DBOTAN_TOOLS_ONLY
	-DBOTAN_MINIMAL_BIGINT
)

ADD_DEFINITIONS(
  -DBOTAN_MP_WORD_BITS=32
  -DBOTAN_KARAT_MUL_THRESHOLD=12
  -DBOTAN_KARAT_SQR_THRESHOLD=12
  -DBOTAN_EXT_MUTEX_QT
)

if(UNIX)
   ADD_DEFINITIONS( -DBOTAN_EXT_ALLOC_MMAP)
endif(UNIX)

SET( botan_SOURCES
	${botan_BASE}/util.cpp
	${botan_BASE}/exceptn.cpp
	${botan_BASE}/mutex.cpp
	${botan_BASE}/mux_qt/mux_qt.cpp
	${botan_BASE}/charset.cpp
	${botan_BASE}/defalloc.cpp
	${botan_BASE}/mp_comba.cpp
	${botan_BASE}/mp_mul.cpp
	${botan_BASE}/mp_shift.cpp
	${botan_BASE}/mp_misc.cpp
	${botan_BASE}/divide.cpp
	${botan_BASE}/big_base.cpp
	${botan_BASE}/big_code.cpp
	${botan_BASE}/big_io.cpp
	${botan_BASE}/big_ops2.cpp
	${botan_BASE}/big_ops3.cpp
	${botan_BASE}/bit_ops.cpp
	${botan_BASE}/libstate.cpp
	${botan_BASE}/mem_pool.cpp
	${botan_BASE}/modules.cpp
	${botan_BASE}/mp_asm.cpp
	${botan_BASE}/mp_mulop.cpp
	${botan_BASE}/parsing.cpp
)

IF (UNIX)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_unix/mlock.cpp)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/alloc_mmap/mmap_mem.cpp)
ENDIF (UNIX)

IF(WIN32)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_win32/mlock.cpp)
ENDIF(WIN32)

MY_AUTOMOC( moc_SOURCES )
SET( SOURCES ${SOURCES} ${moc_SOURCES} ${nonmoc_SOURCES} )

SET( SOURCES ${SOURCES} ${botan_SOURCES})

qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_core.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_cert.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_keystore.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qcaprovider.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_publickey.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_securelayer.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_securemessage.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_support.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qpipe.h")
qt4_wrap_cpp( SOURCES "qca_safeobj.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_safetimer.h")

add_library(${QCA_LIB_NAME} ${SOURCES}  ${public_HEADERS})
TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} ${QT_QTCORE_LIBRARY})

if(WIN32)
	TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} crypt32 ws2_32)
endif(WIN32)

if(APPLE)
   set(COREFOUNDATION_LIBRARY "-framework CoreFoundation")
   set(COREFOUNDATION_LIBRARY_SECURITY "-framework Security")
   TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} ${COREFOUNDATION_LIBRARY} ${COREFOUNDATION_LIBRARY_SECURITY})
endif(APPLE)

if(NOT ANDROID)
  set_target_properties(${QCA_LIB_NAME} PROPERTIES
                        VERSION ${QCA_LIB_MAJOR_VERSION}.${QCA_LIB_MINOR_VERSION}.${QCA_LIB_PATCH_VERSION}
                        SOVERSION ${QCA_LIB_MAJOR_VERSION}
                        )
endif()

set_target_properties(${QCA_LIB_NAME} PROPERTIES
                      DEFINE_SYMBOL QCA_MAKEDLL
                      PUBLIC_HEADER "${public_HEADERS}"
                      FRAMEWORK ${OSX_FRAMEWORK}
                      EXPORT_NAME ${QCA_LIB_NAME}
                      )

if(NOT DEVELOPER_MODE)
  # Do not split 'PUBLIC_HEADER ...' line. It means install headers to folder
  # and set this folder as -I flag for imported target.
  # Also EXPORT doesn't actually install any files. It only created a new target.
  install(TARGETS ${QCA_LIB_NAME} EXPORT ${QCA_CONFIG_NAME_BASE}Targets
          LIBRARY DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          RUNTIME DESTINATION "${QCA_BINARY_INSTALL_DIR}"
          ARCHIVE DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          FRAMEWORK DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          PUBLIC_HEADER DESTINATION "${QCA_FULL_INCLUDE_INSTALL_DIR}" INCLUDES DESTINATION "${QCA_FULL_INCLUDE_INSTALL_DIR}"
  )
  install_pdb(${QCA_LIB_NAME} ${QCA_BINARY_INSTALL_DIR})
endif()

=== examples/hashtest/CMakeLists.txt ===
set(hashtest_bin_SRCS hashtest.cpp)  

add_executable(hashtest ${hashtest_bin_SRCS})

target_link_qca_libraries(hashtest)

=== examples/keyloader/CMakeLists.txt ===
set(keyloader_bin_SRCS keyloader.cpp)  

MY_AUTOMOC( keyloader_bin_SRCS )

add_executable(keyloader ${keyloader_bin_SRCS})

target_link_qca_libraries(keyloader)

=== examples/sslservtest/CMakeLists.txt ===
set(sslservtest_bin_SRCS sslservtest.cpp)  

MY_AUTOMOC( sslservtest_bin_SRCS )

add_executable(sslservtest ${sslservtest_bin_SRCS})

target_link_qca_libraries(sslservtest)
target_link_libraries(sslservtest ${QT_QTNETWORK_LIBRARY})

=== plugins/qca-botan/CMakeLists.txt ===
if(WITH_botan_PLUGIN STREQUAL "yes")
  find_package(Botan REQUIRED)
else(WITH_botan_PLUGIN STREQUAL "yes")
  find_package(Botan)
endif(WITH_botan_PLUGIN STREQUAL "yes")

if(BOTAN_FOUND)
  enable_plugin("botan")

  set(QCA_BOTAN_SOURCES qca-botan.cpp)
  add_definitions(${BOTAN_CFLAGS})
  my_automoc(QCA_BOTAN_SOURCES)
  add_library(qca-botan ${PLUGIN_TYPE} ${QCA_BOTAN_SOURCES})

  if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
    set_property(TARGET qca-botan  PROPERTY SUFFIX ".dylib")
  endif()

  target_link_libraries(qca-botan ${QT_QTCORE_LIBRARY} ${QCA_LIB_NAME} ${BOTAN_LIBRARIES})

  if(NOT DEVELOPER_MODE)
    install(TARGETS qca-botan
            LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

    install_pdb(qca-botan ${QCA_CRYPTO_INSTALL_DIR})
  endif()

else(BOTAN_FOUND)
  disable_plugin("botan")
endif(BOTAN_FOUND)

=== plugins/qca-gcrypt/CMakeLists.txt ===
if(WITH_gcrypt_PLUGIN STREQUAL "yes")
  find_package(LibGcrypt REQUIRED)
else(WITH_gcrypt_PLUGIN STREQUAL "yes")
  find_package(LibGcrypt)
endif(WITH_gcrypt_PLUGIN STREQUAL "yes")

if(LIBGCRYPT_FOUND)
  include(CheckTypeSize)

  set(remember_includes ${CMAKE_EXTRA_INCLUDE_FILES})
  set(remember_defines ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_EXTRA_INCLUDE_FILES gcrypt.h)
  set(CMAKE_REQUIRED_FLAGS ${LIBGCRYPT_CFLAGS})
  check_type_size(gcry_error_t GCRY_ERROR_T)
  set(CMAKE_REQUIRED_FLAGS ${remember_defines})
  set(CMAKE_EXTRA_INCLUDE_FILES ${remember_includes})
  if(HAVE_GCRY_ERROR_T)
    enable_plugin("gcrypt")

    set(QCA_GCRYPT_SOURCES qca-gcrypt.cpp)
    add_definitions(${LIBGCRYPT_CFLAGS})
    my_automoc(QCA_GCRYPT_SOURCES)
    add_library(qca-gcrypt ${PLUGIN_TYPE} ${QCA_GCRYPT_SOURCES})

    if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
      set_property(TARGET qca-gcrypt PROPERTY SUFFIX ".dylib")
    endif()

    target_link_libraries(qca-gcrypt ${QT_QTCORE_LIBRARY} ${QCA_LIB_NAME} ${LIBGCRYPT_LIBRARIES})

    if(NOT DEVELOPER_MODE)
      install(TARGETS qca-gcrypt
              LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
              ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
              RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

      install_pdb(qca-gcrypt ${QCA_CRYPTO_INSTALL_DIR})
    endif()
  else(HAVE_GCRY_ERROR_T)
    message(STATUS "libgcrypt seems to be too old")
    disable_plugin("gcrypt")
  endif(HAVE_GCRY_ERROR_T)
else(LIBGCRYPT_FOUND)
  disable_plugin("gcrypt")
endif(LIBGCRYPT_FOUND)

=== plugins/qca-gnupg/CMakeLists.txt ===
# QCA GnuPG

enable_plugin("gnupg")

set(QCA_GNUPG_MOC_SOURCES
  qca-gnupg.cpp
)

set(QCA_GNUPG_NONMOC_SOURCES
  gpgop.cpp
  utils.cpp
  gpgproc/sprocess.cpp
  mypgpkeycontext.cpp
  mykeystoreentry.cpp
  myopenpgpcontext.cpp
  mykeystorelist.cpp
  mymessagecontext.cpp
  ringwatch.cpp
  lineconverter.cpp
  gpgaction.cpp
  gpgproc/gpgproc.cpp
)

my_automoc(QCA_GNUPG_MOC_SOURCES)

qt4_wrap_cpp(EXTRA_GNUPG_SOURCES gpgop.h)
qt4_wrap_cpp(EXTRA_GNUPG_SOURCES gpgop_p.h)
qt4_wrap_cpp(EXTRA_GNUPG_SOURCES gpgproc/gpgproc.h)
qt4_wrap_cpp(EXTRA_GNUPG_SOURCES gpgproc/gpgproc_p.h)
qt4_wrap_cpp(EXTRA_GNUPG_SOURCES gpgproc/sprocess.h)
qt4_wrap_cpp(EXTRA_GNUPG_SOURCES ringwatch.h)
qt4_wrap_cpp(EXTRA_GNUPG_SOURCES mykeystorelist.h)
qt4_wrap_cpp(EXTRA_GNUPG_SOURCES mymessagecontext.h)
qt4_wrap_cpp(EXTRA_GNUPG_SOURCES gpgaction.h)

add_library(qca-gnupg ${PLUGIN_TYPE} ${QCA_GNUPG_MOC_SOURCES} ${QCA_GNUPG_NONMOC_SOURCES} ${EXTRA_GNUPG_SOURCES})

if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
  set_property(TARGET qca-gnupg PROPERTY SUFFIX ".dylib")
endif()

include_directories(gpgproc)
target_link_libraries(qca-gnupg ${QT_QTCORE_LIBRARY} ${QCA_LIB_NAME})

if (WIN32)
  target_link_libraries(qca-gnupg advapi32)
endif (WIN32)

if(NOT DEVELOPER_MODE)
  install(TARGETS qca-gnupg DESTINATION
          LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
          ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
          RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

  install_pdb(qca-gnupg ${QCA_CRYPTO_INSTALL_DIR})
endif()

=== plugins/qca-logger/CMakeLists.txt ===
# qca-logger

enable_plugin("logger")
set(QCA_LOGGER_SOURCES qca-logger.cpp)
my_automoc( QCA_LOGGER_SOURCES )

add_library(qca-logger ${PLUGIN_TYPE} ${QCA_LOGGER_SOURCES})

if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
  set_property(TARGET qca-logger PROPERTY SUFFIX ".dylib")
endif()

add_definitions(${LOGGERH_DEFINITIONS})
include_directories(${LOGGERH_INCLUDE_DIR})
target_link_libraries(qca-logger ${QT_QTCORE_LIBRARY})
target_link_libraries(qca-logger ${QCA_LIB_NAME})

if(NOT DEVELOPER_MODE)
  install(TARGETS qca-logger
          LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
          ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
          RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

  install_pdb(qca-logger ${QCA_CRYPTO_INSTALL_DIR})
endif()

=== plugins/qca-pkcs11/CMakeLists.txt ===
# qca-pkcs11

if(WITH_pkcs11_PLUGIN STREQUAL "yes")
  find_package(OpenSSL REQUIRED)
  find_package(Pkcs11Helper REQUIRED)
else(WITH_pkcs11_PLUGIN STREQUAL "yes")
  find_package(OpenSSL)
  find_package(Pkcs11Helper)
endif(WITH_pkcs11_PLUGIN STREQUAL "yes")

if(OPENSSL_FOUND AND PKCS11H_FOUND)
  enable_plugin("pkcs11")
  set(QCA_PKCS11_SOURCES qca-pkcs11.cpp)
  my_automoc( QCA_PKCS11_SOURCES )

  add_library(qca-pkcs11 ${PLUGIN_TYPE} ${QCA_PKCS11_SOURCES})

  if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
    set_property(TARGET qca-pkcs11 PROPERTY SUFFIX ".dylib")
  endif()

  add_definitions(${PKCS11H_CFLAGS_OTHER})
  include_directories(${PKCS11H_INCLUDE_DIRS})
  target_link_libraries(qca-pkcs11 ${QT_QTCORE_LIBRARY})
  target_link_libraries(qca-pkcs11 ${QCA_LIB_NAME})
  target_link_libraries(qca-pkcs11 ${PKCS11H_LDFLAGS})
  if (WIN32)
    target_link_libraries(qca-pkcs11 pkcs11-helper.dll)
  endif(WIN32)

  if(NOT DEVELOPER_MODE)
    install(TARGETS qca-pkcs11
            LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

    install_pdb(qca-pkcs11 ${QCA_CRYPTO_INSTALL_DIR})
  endif()
else(OPENSSL_FOUND AND PKCS11H_FOUND)
  disable_plugin("pkcs11")
endif(OPENSSL_FOUND AND PKCS11H_FOUND)

=== tools/mozcerts/CMakeLists.txt ===
project(mozcerts)

set(mozcerts_bin_SRCS main.cpp)  

add_executable(${MOZCERTS_NAME} ${mozcerts_bin_SRCS})

target_link_qca_libraries(${MOZCERTS_NAME})

if(NOT DEVELOPER_MODE)
  install(TARGETS ${MOZCERTS_NAME} DESTINATION "${QCA_BINARY_INSTALL_DIR}")
  install_pdb(${MOZCERTS_NAME} ${QCA_BINARY_INSTALL_DIR})
endif()

=== debian/changelog ===
qca2 (2.1.3-2ubuntu2) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 06 Feb 2018 17:55:11 +0000

qca2 (2.1.3-2ubuntu1) bionic; urgency=medium

  * Sync from Debian Sid. Remaining changes:
    - Conflicts/Replaces libqca2v5 because of the GCC transition.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 27 Jan 2018 21:51:22 -0600

qca2 (2.1.3-2) unstable; urgency=medium

  * Switch to OpenSSL 1.1. (Closes: #850897)
    Backport upstream patches:
    - Disable_missed_openssl_cipher_suites.diff
    - Add_support_for_OpenSSL_1.1.0.diff
  * Remove transitional packages. (Closes: #874758)
  * Migrate to -dbgsym packages.
  * Update symbols files.
  * Fix acc autopkgtest by allowing stderr output.
  * Switch to debhelper compat level 11.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 21 Jan 2018 09:41:22 +0100

qca2 (2.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Remove patches that have been applied upstream:
    - fix_build_without_sslv3.diff
    - fix_base64_decoding_on_ARM.diff

 -- Felix Geyer <fgeyer@debian.org>  Sun, 18 Jun 2017 09:30:07 +0200

qca2 (2.1.1-4) unstable; urgency=medium

  * Fix FTBFS on architectures where char is unsigned.
    - Add fix_base64_decoding_on_ARM.diff

 -- Felix Geyer <fgeyer@debian.org>  Tue, 15 Nov 2016 21:07:14 +0100

qca2 (2.1.1-3) unstable; urgency=medium

  * Keep using openssl 1.0 since upstream doesn't support 1.1 and adapting
    the codebase seems non-trivial. (bug #828519)
  * Update symbols files.

 -- Felix Geyer <fgeyer@debian.org>  Tue, 15 Nov 2016 19:03:12 +0100

=== debian/control ===
Source: qca2
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Felix Geyer <fgeyer@debian.org>,
           Maximiliano Curia <maxy@debian.org>,
Build-Depends: ca-certificates,
               cmake (>= 2.8.12),
               debhelper (>= 11~),
               doxygen,
               libqt4-dev (>= 4.7.0),
               libsasl2-dev,
               libssl-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev
Build-Conflicts: libqca2-dev, qca-dev
Standards-Version: 4.1.3
Homepage: http://delta.affinix.com/qca/
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-req/qca2.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-req/qca2.git/

Package: libqca2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates, libqca2-plugins
Description: libraries for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.

Package: libqca2-plugins
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libqca2-plugin-cyrus-sasl (<< 2.1.0),
        libqca2-plugin-gnupg (<< 2.1.0),
        libqca2-plugin-ossl (<< 2.1.0)
Replaces: libqca2-plugin-cyrus-sasl (<< 2.1.0),
          libqca2-plugin-gnupg (<< 2.1.0),
          libqca2-plugin-ossl (<< 2.1.0)
Description: QCA plugins for libqca2
 This plugin provides cryptographic as well as helper plugins for Qt
 Cryptographic Architecture (QCA).

Package: libqca-qt5-2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates, libqca-qt5-2-plugins
Conflicts: libqca2v5
Replaces: libqca2v5
Description: libraries for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.

Package: libqca-qt5-2-plugins
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QCA plugins for libqca2
 This plugin provides cryptographic as well as helper plugins for Qt
 Cryptographic Architecture (QCA).

Package: qca2-utils
Section: utils
Architecture: any
Depends: libqca2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: libqca2 (<< 2.0.3-3~)
Replaces: libqca2 (<< 2.0.3-3~)
Description: command line tool for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the command line tool for the Qt Cryptographic
 Architecture.

Package: qca-qt5-2-utils
Section: utils
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: command line tool for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the command line tool for the Qt Cryptographic
 Architecture.

Package: libqca2-dev
Section: libdevel
Architecture: any
Depends: libqca2 (= ${binary:Version}), libqt4-dev (>= 4.4.0~), ${misc:Depends}
Suggests: libqca2-doc (= ${source:Version})
Conflicts: qca-dev
Description: development files for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains development files for building software that uses the
 Qt Cryptographic Architecture.

Package: libqca-qt5-2-dev
Section: libdevel
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), qtbase5-dev, ${misc:Depends}
Suggests: libqca2-doc (= ${source:Version})
Conflicts: qca-dev
Description: development files for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains development files for building software that uses the
 Qt Cryptographic Architecture.

Package: libqca2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: qt4-doc | qt5-doc
Suggests: libqca2-dev (>= ${source:Version}) | libqca-qt5-2-dev (>= ${source:Version})
Description: API documentation for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains documentation for developers working with the
 Qt Cryptographic Architecture.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/pkg-kde-tools/qt-kde-team/3/debian-qt-kde.mk

# Enable strict interdependencies
libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk

CFLAGS += -fvisibility=hidden -fvisibility-inlines-hidden
CXXFLAGS += -fvisibility=hidden -fvisibility-inlines-hidden

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

QT5_BUILD_DIR = "build-qt5"
QT5_PACKAGES = $(shell grep Package: debian/control | grep qt5 | sed -e 's/Package: //g')
QT5_DH_EXCLUDE := $(foreach package, $(QT5_PACKAGES), -N $(package))
QT5_DH_INCLUDE := $(foreach package, $(QT5_PACKAGES), -p $(package))

override_dh_auto_clean:
	$(overridden_command)
	$(overridden_command) --builddirectory=$(QT5_BUILD_DIR)

override_dh_auto_configure:
	QT_SELECT=qt4 $(overridden_command) -- \
	    -DQT4_BUILD=ON -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	    -DQCA_FEATURE_INSTALL_DIR="/usr/share/qt4/mkspecs/features"
	QT_SELECT=qt5 $(overridden_command) \
	    --builddirectory=$(QT5_BUILD_DIR) -- \
	    -DQT5_BUILD=ON -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	    -DQCA_FEATURE_INSTALL_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/mkspecs/features"

override_dh_auto_build:
	$(overridden_command)
	$(overridden_command) --builddirectory=$(QT5_BUILD_DIR)
	$(overridden_command) --builddirectory=$(QT5_BUILD_DIR) -- doc

override_dh_auto_test:
	$(overridden_command)
	$(overridden_command) --builddirectory=$(QT5_BUILD_DIR)

override_dh_auto_install:
	$(overridden_command)
	$(overridden_command) --builddirectory=$(QT5_BUILD_DIR)

override_dh_strip:
	$(overridden_command) $(QT5_DH_INCLUDE) --dbgsym-migration='libqca-qt5-2-dbg (<< 2.1.3-2~)'
	$(overridden_command) --remaining-packages --dbgsym-migration='libqca2-dbg (<< 2.1.3-2~)'

=== debian/tests/control ===
# Tests: testsuite
# Depends: @, @builddeps@, build-essential
# Restrictions: build-needed

Tests: acc
Depends: @, dh-acc, exuberant-ctags
Restrictions: allow-stderr

Tests: ciphertest-qt4
Depends: build-essential, cmake, libqca2-dev, libqca2-plugins

Tests: ciphertest-qt5
Depends: build-essential, cmake, libqca-qt5-2-dev, libqca-qt5-2-plugins

=== debian/watch ===
version=3
https://download.kde.org/stable/qca/([\d.]+)/src/qca-([\d.]+)\.tar\.xz

## qca2 2.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,20 +8,15 @@
 
 project(qca)
 
-if(NOT APPLE)
-  cmake_minimum_required(VERSION 2.8.12)
-else()
-  cmake_minimum_required(VERSION 3.0)
-endif()
+cmake_minimum_required(VERSION 3.4)
 
 set(QCA_LIB_MAJOR_VERSION "2")
-set(QCA_LIB_MINOR_VERSION "1")
-set(QCA_LIB_PATCH_VERSION "3")
-
-# Do not automatically link Qt executables to qtmain target on Windows.
-# QCA exucatables use console mode only. Not need to link against
-# qtmain.lib.
-cmake_policy(SET CMP0020 OLD)
+set(QCA_LIB_MINOR_VERSION "2")
+set(QCA_LIB_PATCH_VERSION "1")
+
+if(POLICY CMP0042)
+  cmake_policy(SET CMP0042 OLD)
+endif()
 
 option(BUILD_TESTS "Create test" ON)
 option(BUILD_TOOLS "Compile mozcerts and qcatool" ON)
@@ -47,6 +42,9 @@
 
 option(QT4_BUILD "Force building with Qt4 even if Qt5 is found")
 if (NOT QT4_BUILD)
+  # Do not automatically link Qt executables to qtmain target on Windows.
+  # QCA exucatables use console mode only. Not need to link against qtmain.lib.
+  set(Qt5_NO_LINK_QTMAIN ON)
   find_package(Qt5Core QUIET)
   mark_as_advanced(Qt5Core_DIR)
 endif()
@@ -57,7 +55,11 @@
   message(STATUS "Building with Qt5 support")
   # Got from ECM
   # Distros have no ECM. So I just copied required cmake modules.
-  find_package(Qt5Transitional REQUIRED Core Network)
+  if(BUILD_TESTS)
+    find_package(Qt5Transitional REQUIRED Core Network)
+  else()
+    find_package(Qt5Transitional REQUIRED Core)
+  endif()
   include(ECMQt4To5Porting)
 
   include(GNUInstallDirs)
@@ -67,6 +69,9 @@
 else()
   set(QT_MIN_VERSION "4.7.0")
   set(QT_USE_IMPORTED_TARGETS ON)
+  # Do not automatically link Qt executables to qtmain target on Windows.
+  # QCA exucatables use console mode only. Not need to link against qtmain.lib.
+  set(QT4_NO_LINK_QTMAIN ON)
   if(BUILD_TESTS)
     find_package(Qt4 REQUIRED QtCore QtNetwork QtTest)
   else(BUILD_TESTS)
@@ -126,8 +131,8 @@
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align")
      endif()
 
-     set ( CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wno-long-long -ansi -Wundef -Werror-implicit-function-declaration -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -Wmissing-format-attribute -fno-common")
-     set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -ansi -Wundef -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -fno-check-new -fno-common")
+     set ( CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wno-long-long -Wundef -Werror-implicit-function-declaration -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -Wmissing-format-attribute -fno-common")
+     set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -Wundef -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -fno-check-new -fno-common")
    endif (CMAKE_SYSTEM_NAME MATCHES Linux)
 endif (CMAKE_COMPILER_IS_GNUCXX)
 
@@ -292,10 +297,3 @@
 else ( WIN32 )
   if ( DEFINED ENV{QC_CERTSTORE_PATH} )
     if(EXISTS $ENV{QC_CERTSTORE_PATH})
-      set( qca_CERTSTORE $ENV{QC_CERTSTORE_PATH})
-    else(EXISTS $ENV{QC_CERTSTORE_PATH})
-      # path to try
-    endif(EXISTS $ENV{QC_CERTSTORE_PATH})
-  else( DEFINED ENV{QC_CERTSTORE_PATH} )
-    set( toTry
-      "/etc/ssl/certs/ca-certificates.crt"

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -148,9 +148,15 @@
 endif(WIN32)
 
 if(APPLE)
-   set(COREFOUNDATION_LIBRARY "-framework CoreFoundation")
-   set(COREFOUNDATION_LIBRARY_SECURITY "-framework Security")
-   TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} ${COREFOUNDATION_LIBRARY} ${COREFOUNDATION_LIBRARY_SECURITY})
+  set(COREFOUNDATION_LIBRARY "-framework CoreFoundation")
+  set(COREFOUNDATION_LIBRARY_SECURITY "-framework Security")
+  TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} ${COREFOUNDATION_LIBRARY} ${COREFOUNDATION_LIBRARY_SECURITY})
+
+  if(OSX_FRAMEWORK AND NOT USE_RELATIVE_PATHS)
+    set_target_properties(${QCA_LIB_NAME} PROPERTIES
+                          INSTALL_NAME_DIR "${QCA_LIBRARY_INSTALL_DIR}"
+    )
+  endif()
 endif(APPLE)
 
 if(NOT ANDROID)

=== plugins/qca-ossl/CMakeLists.txt ===
# QCA OSSL

if(WITH_ossl_PLUGIN STREQUAL "yes")
  find_package(OpenSSL REQUIRED)
else(WITH_ossl_PLUGIN STREQUAL "yes")
  find_package(OpenSSL)
endif(WITH_ossl_PLUGIN STREQUAL "yes")

if(OPENSSL_FOUND)
  enable_plugin("ossl")

  include(CheckFunctionExists)
  set(CMAKE_REQUIRED_LIBRARIES ${OPENSSL_LIBRARIES})
  check_function_exists(EVP_md2 HAVE_OPENSSL_MD2)
  if(HAVE_OPENSSL_MD2)
    add_definitions(-DHAVE_OPENSSL_MD2)
  else(HAVE_OPENSSL_MD2)
    message(WARNING "qca-ossl will be compiled without MD2 digest algorithm support")
  endif(HAVE_OPENSSL_MD2)

  check_function_exists(EVP_aes_128_ctr HAVE_OPENSSL_AES_CTR)
  if(HAVE_OPENSSL_AES_CTR)
    add_definitions(-DHAVE_OPENSSL_AES_CTR)
  else(HAVE_OPENSSL_AES_CTR)
    message(WARNING "qca-ossl will be compiled without AES CTR mode encryption support")
  endif(HAVE_OPENSSL_AES_CTR)

  check_function_exists(EVP_aes_128_gcm HAVE_OPENSSL_AES_GCM)
  if(HAVE_OPENSSL_AES_GCM)
    add_definitions(-DHAVE_OPENSSL_AES_GCM)
  else()
    message(WARNING "qca-ossl will be compiled without AES GCM mode encryption support")
  endif()

  check_function_exists(EVP_aes_128_ccm HAVE_OPENSSL_AES_CCM)
  if(HAVE_OPENSSL_AES_CCM)
    add_definitions(-DHAVE_OPENSSL_AES_CCM)
  else()
    message(WARNING "qca-ossl will be compiled without AES CCM mode encryption support")
  endif()

  check_function_exists(EVP_sha HAVE_OPENSSL_SHA0)
  if(HAVE_OPENSSL_SHA0)
    add_definitions(-DHAVE_OPENSSL_SHA0)
  else(HAVE_OPENSSL_SHA0)
    message(WARNING "qca-ossl will be compiled without SHA-0 digest algorithm support")
  endif(HAVE_OPENSSL_SHA0)

  set(QCA_OSSL_SOURCES qca-ossl.cpp)

  my_automoc( QCA_OSSL_SOURCES )

  add_library(qca-ossl ${PLUGIN_TYPE} ${QCA_OSSL_SOURCES})

  if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
    set_property(TARGET qca-ossl PROPERTY SUFFIX ".dylib")
  endif()

  target_link_libraries(qca-ossl ${QT_QTCORE_LIBRARY})
  target_link_libraries(qca-ossl ${QCA_LIB_NAME})
  target_link_libraries(qca-ossl OpenSSL::SSL OpenSSL::Crypto)

  if(NOT DEVELOPER_MODE)
    install(TARGETS qca-ossl
            LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

    install_pdb(qca-ossl ${QCA_CRYPTO_INSTALL_DIR})
  endif()

  else(OPENSSL_FOUND)
  disable_plugin("ossl")
endif(OPENSSL_FOUND)

=== unittest/cipherunittest/CMakeLists.txt ===
enable_testing()

set(cipherunittest_bin_HDRS cipherunittest.h)
set(cipherunittest_bin_SRCS cipherunittest.cpp)

qt4_wrap_cpp(EXTRA_SRCS cipherunittest.h)

add_executable(cipherunittest ${cipherunittest_bin_SRCS} ${EXTRA_SRCS} ${cipherunittest_bin_HDRS})

target_link_qca_test_libraries(cipherunittest)

add_qca_test(cipherunittest "SymmetricCipher")

=== debian/changelog ===
qca2 (2.2.1-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:09:36 +0100

qca2 (2.2.1-2) unstable; urgency=medium

  * Stop building packages for Qt 4. (Closes: #875133)
  * Switch to debhelper compat level 12.

 -- Felix Geyer <fgeyer@debian.org>  Mon, 26 Aug 2019 19:22:56 +0200

qca2 (2.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches that have been fixed upstream:
    - Add_support_for_OpenSSL_1.1.0.diff
    - Disable_missed_openssl_cipher_suites.diff
  * Update symbols files.
  * Adapt watch file to new URL.
  * Point Vcs contorl fields to salsa.d.o
  * Switch to new upstream URL.
  * Update copyright file.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 14 Jul 2019 23:56:19 +0200

=== debian/control ===
Source: qca2
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Felix Geyer <fgeyer@debian.org>,
           Maximiliano Curia <maxy@debian.org>,
Build-Depends: ca-certificates,
               cmake (>= 2.8.12),
               debhelper-compat (= 12),
               doxygen,
               libsasl2-dev,
               libssl-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev
Build-Conflicts: libqca2-dev, qca-dev
Standards-Version: 4.1.3
Homepage: https://userbase.kde.org/QCA
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qca2.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qca2

Package: libqca-qt5-2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates, libqca-qt5-2-plugins
Description: libraries for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.

Package: libqca-qt5-2-plugins
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QCA plugins for libqca2
 This plugin provides cryptographic as well as helper plugins for Qt
 Cryptographic Architecture (QCA).

Package: qca-qt5-2-utils
Section: utils
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: command line tool for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the command line tool for the Qt Cryptographic
 Architecture.

Package: libqca-qt5-2-dev
Section: libdevel
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), qtbase5-dev, ${misc:Depends}
Suggests: libqca2-doc (= ${source:Version})
Conflicts: qca-dev
Description: development files for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains development files for building software that uses the
 Qt Cryptographic Architecture.

Package: libqca2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: qt5-doc
Suggests: libqca-qt5-2-dev (>= ${source:Version})
Description: API documentation for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains documentation for developers working with the
 Qt Cryptographic Architecture.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/pkg-kde-tools/qt-kde-team/3/debian-qt-kde.mk

# Enable strict interdependencies
libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk

CFLAGS += -fvisibility=hidden -fvisibility-inlines-hidden
CXXFLAGS += -fvisibility=hidden -fvisibility-inlines-hidden

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_clean:
	$(overridden_command) --builddirectory=build

override_dh_auto_configure:
	QT_SELECT=qt5 $(overridden_command)  --builddirectory=build -- \
	    -DQT5_BUILD=ON -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	    -DQCA_FEATURE_INSTALL_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/mkspecs/features"

override_dh_auto_build:
	$(overridden_command) --builddirectory=build
	$(overridden_command) --builddirectory=build -- doc

override_dh_auto_install:
	$(overridden_command) --builddirectory=build

override_dh_auto_test:
	$(overridden_command) --builddirectory=build

override_dh_strip:
	$(overridden_command) --dbgsym-migration='libqca-qt5-2-dbg (<< 2.1.3-2~)'

=== debian/tests/control ===
# Tests: testsuite
# Depends: @, @builddeps@, build-essential
# Restrictions: build-needed

Tests: acc
Depends: @, dh-acc, exuberant-ctags
Restrictions: allow-stderr

Tests: ciphertest-qt5
Depends: build-essential, cmake, libqca-qt5-2-dev, libqca-qt5-2-plugins

=== debian/watch ===
version=4
https://download.kde.org/stable/qca/([\d.]+)/qca-([\d.]+)\.tar\.xz
